\documentclass{article}
\usepackage{fullpage}
\title{\textsc{net.quadium.ldap}\\LDAP Library User Manual}
\author{Tim Howe\\\texttt{vsync@quadium.net}}
\newcommand{\ldap}{\texttt{NET.QUADIUM.LDAP}}
\newcommand{\function}[1]{\texttt{\textsc{#1}}}
\newcommand{\variable}[1]{\texttt{\textsc{#1}}}
\begin{document}
\maketitle

\section{Overview}
\label{sec:overview}

\ldap{} is a library for interacting with LDAP servers by means of the
OpenLDAP command line utilities.  It utilizes the
\texttt{NET.QUADIUM.LDIF} library to communicate with these utilities.
This approach, while perhaps lacking efficiency (although hopefully
this can be ameliorated by means of caching and appropriate scoping to
avoid redundant operations) has the advantage that it can be easily
ported to any environment which can run subprocesses and has the
OpenLDAP clients available.

\section{Settings}
\begin{description}
\item[*password-file*] A string designating file containing a password
  to be used for LDAP authentication.
\item[*simple-auth-p*] Whether the LDAP utilities should use simple
  authentication.
\item[*ldapsearch-command*] The command to invoke the ``ldapsearch''
  utility.
\item[*ldapmodify-command*] The command to invoke the ``ldapmodify''
  utility.
\end{description}

\section{Filters}

\ldap{} has the ability to convert search filters from a very Lispy
sexp form into that expected by LDAP.

\begin{description}
\item[convert-search-filter {\mdseries\itshape filter}]
\ \\Returns a filter string created from the FILTER sexp.

Example:
\begin{verbatim}(convert-search-filter '(and (not (or (= "objectClass" "computer")
                                      (= "objectClass" "group")))
                             (= "location" "millenia*")))
  =>
"(&(!(|(objectClass=computer)(objectClass=group)))(location=millenia*))"
\end{verbatim}
\end{description}

\section{Searching}

\begin{description}
\item[ldap-search {\mdseries\itshape filter attributes {\ttfamily\slshape\&key} base (scope :sub) (password-file *password-file*) (simple-auth-p *simple-auth-p*)}]
\ \\Searches by FILTER and returns matching ATTRIBUTES.
FILTER may
  be a filter string in the form expected by ldap\_search(3), or a
  sexp which will be converted by CONVERT-SEARCH-FILTER.  A null
  FILTER is equivalent to \texttt{"objectClass=*"}.  ATTRIBUTES is a
  list of strings, each string designating the name of an attribute.
  If ATTRIBUTES is empty, all attributes of a matching record will be
  returned.

\item[ldap-fetch-by-dn {\mdseries\itshape dn attributes {\ttfamily\slshape\&key} base (password-file *password-file*) (simple-auth-p *simple-auth-p*)}]
\ \\Fetches the object designated by the distinguished name DN.
ATTRIBUTES are handled as by LDAP-SEARCH.
\end{description}

\section{Modifying}

\begin{description}
\item[ldap-modify {\mdseries\itshape change-records {\ttfamily\slshape\&key} (password-file *password-file*) (simple-auth-p *simple-auth-p*)}]
\ \\Transmits CHANGE-RECORDS to the LDAP server for execution.

\end{description}

\end{document}
